"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActorService = void 0;
var reflection_service_1 = require("./reflection.service");
var ActorService = /** @class */ (function () {
    function ActorService(project) {
        this.project = project;
        this.reflectionService = new reflection_service_1.ReflectionService();
    }
    ActorService.prototype.scan = function () {
        var _this = this;
        var actors = [];
        this.reflectionService.visitClassDecorators(this.project, function (d) {
            var actor = _this.getActorFromDecorator(d);
            if (actor != null) {
                actors.push(actor);
            }
            var groupedActors = _this.getActorsFromDecorator(d);
            groupedActors.forEach(function (a) { return actors.push(a); });
        });
        return actors;
    };
    ActorService.prototype.getActorFromDecorator = function (d) {
        var name = this.reflectionService.getValueFromDecorator(d, "ContextActor");
        if (name != null) {
            return { name: name };
        }
        return null;
    };
    ActorService.prototype.getActorsFromDecorator = function (d) {
        var names = this.reflectionService.getArrayValueFromDecorator(d, "ContextActors");
        var actors = names.map(function (name) {
            return { name: name };
        });
        return actors;
    };
    return ActorService;
}());
exports.ActorService = ActorService;
