"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscribedEndpointService = void 0;
var reflection_service_1 = require("./reflection.service");
var SubscribedEndpointService = /** @class */ (function () {
    function SubscribedEndpointService(project) {
        this.project = project;
        this.reflectionService = new reflection_service_1.ReflectionService();
    }
    SubscribedEndpointService.prototype.scan = function () {
        var _this = this;
        var results = [];
        this.reflectionService.visitClassDecorators(this.project, function (d) {
            var result = _this.getRestApiEndpointFromDecorator(d);
            if (result != null) {
                results.push(result);
            }
        });
        return results;
    };
    SubscribedEndpointService.prototype.getRestApiEndpointFromDecorator = function (d) {
        var name = this.reflectionService.getValueFromDecorator(d, "ContextClient");
        if (name != null) {
            return this.createAnonymousEndpoint(name);
        }
        return null;
    };
    SubscribedEndpointService.prototype.createAnonymousEndpoint = function (componentName) {
        var endpoint = {
            componentName: componentName,
            path: "/",
            requestMethod: "GET" // need some value otherwise invalid
        };
        return endpoint;
    };
    return SubscribedEndpointService;
}());
exports.SubscribedEndpointService = SubscribedEndpointService;
