"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextMapScannerMojo = void 0;
var mojo_parameters_1 = require("./infrastructure/mojo-parameters");
var scan_service_1 = require("./application/scan.service");
var ContextMapScannerMojo = /** @class */ (function () {
    function ContextMapScannerMojo(key, source, componentName, systemName) {
        this.key = key;
        this.source = source;
        this.componentName = componentName;
        this.systemName = systemName;
    }
    ContextMapScannerMojo.prototype.execute = function () {
        console.info("Generating contextmap");
        var parameters = this.createParameters();
        var scanService = new scan_service_1.ScanService(parameters);
        scanService.scan();
        console.info("Finished scan");
    };
    ContextMapScannerMojo.prototype.createParameters = function () {
        var parameters = new mojo_parameters_1.MojoParameters();
        parameters.setKey(this.key);
        parameters.source = this.source;
        parameters.componentName = this.componentName;
        parameters.systemName = this.systemName;
        return parameters;
    };
    return ContextMapScannerMojo;
}());
exports.ContextMapScannerMojo = ContextMapScannerMojo;
