"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpService = void 0;
var async_call_blocker_1 = require("../async-call-blocker");
//const https = require("http");
var https = require("https");
var HttpService = /** @class */ (function () {
    function HttpService() {
    }
    HttpService.prototype.post = function (path, requestBody, authHeader, expectResponseBody) {
        if (authHeader === void 0) { authHeader = null; }
        if (expectResponseBody === void 0) { expectResponseBody = true; }
        var options = {
            // hostname: "localhost",
            // port: 8181,
            hostname: "contextmap-server.azurewebsites.net",
            port: 443,
            path: path,
            method: "POST",
            headers: {
                "Content-Type": "application/json",
                Authorization: authHeader
            }
        };
        var ready = false;
        var responseBody = null;
        try {
            var req = https.request(options, function (response) {
                response.on("data", function (d) {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        responseBody = JSON.parse(d);
                    }
                    else {
                        console.error("Error: " + d);
                    }
                    ready = true;
                });
                response.on("end", function () {
                    // If we don't expect the server to send data via response-body, then we wont get a "data"-event
                    // so we need to mark the request as ready upon receiving the "end"-event
                    if (!expectResponseBody) {
                        ready = true;
                    }
                });
            });
            req.on("error", function (error) {
                console.error("Error: " + error);
                ready = true;
            });
            var jsonString = JSON.stringify(requestBody);
            req.write(jsonString);
            req.end();
        }
        catch (e) {
            ready = true;
            console.error("Error: " + e);
        }
        // Block until response received
        while (!ready) {
            (0, async_call_blocker_1.blockExecution)();
        }
        return responseBody;
    };
    return HttpService;
}());
exports.HttpService = HttpService;
