"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatDateTime = exports.formatDate = exports.formatTimestamp = exports.gitTimestampToDate = exports.createDateInPassed = void 0;
function createDateInPassed(nrOfDaysAgo) {
    return new Date(new Date().valueOf() - 1000 * 60 * 60 * 24 * nrOfDaysAgo);
}
exports.createDateInPassed = createDateInPassed;
function gitTimestampToDate(timestamp) {
    return new Date(timestamp * 1000);
}
exports.gitTimestampToDate = gitTimestampToDate;
function formatTimestamp(timestamp) {
    var date = gitTimestampToDate(timestamp);
    return formatDate(date);
}
exports.formatTimestamp = formatTimestamp;
function formatDate(date) {
    var year = date.getFullYear();
    var month = ('' + (date.getMonth() + 1)).padStart(2, '0');
    var day = ('' + date.getDate()).padStart(2, '0');
    return year + "-" + month + "-" + day;
}
exports.formatDate = formatDate;
function formatDateTime(date) {
    var year = date.getFullYear();
    var month = ('' + (date.getMonth() + 1)).padStart(2, '0');
    var day = ('' + date.getDate()).padStart(2, '0');
    var hour = ('' + date.getHours()).padStart(2, '0');
    var minute = ('' + date.getMinutes()).padStart(2, '0');
    var second = ('' + date.getSeconds()).padStart(2, '0');
    return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second;
}
exports.formatDateTime = formatDateTime;
