"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MojoParameters = void 0;
var buffer_1 = require("buffer");
var MojoParameters = /** @class */ (function () {
    function MojoParameters() {
        this.clearTextText = "";
        this.source = '';
        this.componentName = null;
        this.systemName = null;
    }
    MojoParameters.prototype.setKey = function (key) {
        if (key == null || key.length === 0) {
            throw new Error("Missing required key configuration parameter");
        }
        var keyString = buffer_1.Buffer.from(key, 'base64').toString();
        var colonIndex = keyString.indexOf(":");
        if (colonIndex < 0) {
            throw new Error("Invalid key configuration parameter");
        }
        this.clearTextText = keyString;
    };
    MojoParameters.prototype.getUsername = function () {
        var colonIndex = this.clearTextText.indexOf(":");
        return this.clearTextText.substring(0, colonIndex);
    };
    MojoParameters.prototype.getPassword = function () {
        var colonIndex = this.clearTextText.indexOf(":");
        return this.clearTextText.substring(colonIndex + 1);
    };
    return MojoParameters;
}());
exports.MojoParameters = MojoParameters;
