"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationPackageJsonFile = void 0;
var configuration_resource_1 = require("./configuration-resource");
var async_call_blocker_1 = require("../async-call-blocker");
var component_type_1 = require("../../model/component-type");
var readJson = require("read-package-json");
var ConfigurationPackageJsonFile = /** @class */ (function (_super) {
    __extends(ConfigurationPackageJsonFile, _super);
    function ConfigurationPackageJsonFile() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ConfigurationPackageJsonFile.create = function (file) {
        var resource = new ConfigurationPackageJsonFile();
        resource.readPackageJson(file);
        return resource;
    };
    ConfigurationPackageJsonFile.prototype.getDomainVisionStatement = function () {
        return this.fileContent.description;
    };
    ConfigurationPackageJsonFile.prototype.getComponentType = function () {
        var _a, _b;
        var componentTypeProperty = (_b = (_a = this.fileContent.contextmap) === null || _a === void 0 ? void 0 : _a.scan) === null || _b === void 0 ? void 0 : _b.componentType;
        if (componentTypeProperty != null && componentTypeProperty.length > 0) {
            var matchingEnum = Object.keys(component_type_1.ComponentType).find(function (enumName) { return enumName === componentTypeProperty; });
            if (!matchingEnum) {
                var supportedValues = Object.keys(component_type_1.ComponentType).join(", ");
                console.error("Unable to map provided component-type " + componentTypeProperty + " to any of the supported values: " + supportedValues);
            }
            return component_type_1.ComponentType[matchingEnum]; // casting need to make it stop complain
        }
        return component_type_1.ComponentType.MICROFRONTEND;
    };
    ConfigurationPackageJsonFile.prototype.getName = function () {
        return this.fileContent.name;
    };
    ConfigurationPackageJsonFile.prototype.getVersion = function () {
        return this.fileContent.version;
    };
    ConfigurationPackageJsonFile.prototype.getSystemName = function () {
        var _a, _b;
        return (_b = (_a = this.fileContent.contextmap) === null || _a === void 0 ? void 0 : _a.scan) === null || _b === void 0 ? void 0 : _b.systemName;
    };
    ConfigurationPackageJsonFile.prototype.getTeam = function () {
        if (this.fileContent.author != null &&
            this.fileContent.author.name != null) {
            return this.fileContent.author.name;
        }
        return "";
    };
    ConfigurationPackageJsonFile.prototype.getUrlBuildPipeline = function () {
        return "";
    };
    ConfigurationPackageJsonFile.prototype.getUrlDocumentation = function () {
        return this.fileContent.homepage;
    };
    ConfigurationPackageJsonFile.prototype.getUrlIssueManagement = function () {
        var _a;
        return (_a = this.fileContent.bugs) === null || _a === void 0 ? void 0 : _a.url;
    };
    ConfigurationPackageJsonFile.prototype.getUrlVersionControl = function () {
        var _a;
        return (_a = this.fileContent.repository) === null || _a === void 0 ? void 0 : _a.url;
    };
    ConfigurationPackageJsonFile.prototype.readPackageJson = function (file) {
        var self = this;
        readJson(file, null, false, function (er, data) {
            if (er) {
                console.error("Error: There was an error reading package.json");
                return;
            }
            self.fileContent = data;
        });
        // Block until file is read
        while (!self.fileContent) {
            (0, async_call_blocker_1.blockExecution)();
        }
    };
    return ConfigurationPackageJsonFile;
}(configuration_resource_1.ConfigurationResource));
exports.ConfigurationPackageJsonFile = ConfigurationPackageJsonFile;
