import { ScannedComponent } from "./scanned-component";
import { ScanExecution } from "./scan-execution";
import { DomainObject } from "./domain-object";
import { Actor } from "./actor";
import { RestApiEndpoint } from "./rest-api-endpoint";
import { GlossaryTerm } from "./glossary-term";
import { CommitDetail } from "./commit-detail";
import { ReleaseOverview } from "./release-overview";
import { DecisionRecordOverview } from "./decision-record-overview";
import { FeatureFileOverview } from "./feature-file-overview";
export interface Scan {
    scannedComponent: ScannedComponent;
    execution: ScanExecution;
    commitDetails: CommitDetail[];
    pluginName: string;
    pluginVersion: string;
    entities: DomainObject[];
    decisionRecordOverviews: DecisionRecordOverview[];
    featureFileOverviews: FeatureFileOverview[];
    releaseOverviews: ReleaseOverview[];
    subscribedEndpoints: RestApiEndpoint[];
    actors: Actor[];
    glossaryTerms: GlossaryTerm[];
}
export declare function createScan(version: string): Scan;
